# **Version uses MPLAX.X
# Program to contruct a constant from an elf disassembly
# first dissasemble theelf file something like:
# pic32-objdump -d  plug.elf > dis.txt

import sys, os
import string

# valid is when its a hex digit and is an 8 length word
def isValid(s):
    #print s,len(s)
    if all(c in string.hexdigits for c in s):
        #print "len=",len(s)
        if len(s) == 8:
            return True
        else:
            return False    

# given a dissasebbly file (inName), this returns 3 items:
# 1) valid if the function name exists in the file
# 2) the number of words from the beginning of the file to the function
# 3) all of the words from .text: to the end of the file
def get_ops(inName,function,startAddress):
    out = []
    valid = False
    wordcount = 0
    inF = open("dis.txt", 'r').readlines()
    fname = "<"+function+">:"
    # get to the start of the functions which is always 
    for i in range(len(inF)):
        #print inF[i]
        if inF[i].find(startAddress+':') >= 0:
            break
     # text area found        
    if i < len(inF): 
        for j in range(i,len(inF)):
            # no need to include main() or there after ** 
            #if inF[j].find('<main>:') >= 0:
            #    break;
            # need the number of words to the start of the required 
            # function so when it exists the wordcount stops
            if inF[j].find(fname) >= 0:
                valid = True # function exists 
            # ignore title lines which have an address that would get picked 
            # up as data    
            if '>:' in inF[j]: 
                continue # ignore lines with this 
            op = inF[j].split() 
            for n in op:
                if ':' in n: continue # skip address
                if isValid(n):
                    # count all words up to function
                    if not valid: wordcount += 1
                    out.append(n)
                else:
                    # sometimes there is a valid word in the op codes so
                    # dont look at anything after a non-valid item
                    break    
    return valid, wordcount, out


# creates a file from the supplied list of opcodes
def create_const(inFile,outFile,function,address):
    count = 2
    valid = False
    wordcount = 0
    tmp = ''
    valid, wordcount, ops = get_ops(inFile,function,address)
    outF = open(outFile, 'w')
    outF.write("// File created by plugin1.py for ByPic plug in, see www.bypic.co.uk\n")
    if not valid:
        outF.write("// Function name given was not valid:\n"+function)
        outF.close()
        return
    tmp = "// Offset is {0} words {1} bytes\n".format(wordcount,wordcount*4)    
    outF.write(tmp)    
    outF.write("constant {0} ".format(function))
    outF.write("{ ");
    for i in range(0,len(ops)):
        # last one
        if i == len(ops)-1:
            outF.write("0x{0} ".format(ops[i]))
            outF.write("} \n")
            break
        outF.write("0x{0}, ".format(ops[i]))
        count+=1
        if count > 5:
            count = 0
            outF.write("\\ \n")
    outF.close()
    
def main():
    if len(sys.argv) < 4:
        print "usage: plugin1.py <temporary file> <function name> <compile address>"
        print "Example: plugin1.py dis.txt p_test 9d027d60"
        print "Notes:"
        print "See instructions as this needs to be in the correct place"
        return
    print "Using {0} to create {1}".format(sys.argv[1],sys.argv[2])
    os.system('pic32-objdump -d  dist\default\production\plugin.X.production.elf > dis.txt')
    create_const('dis.txt',sys.argv[2]+".bas",sys.argv[2],sys.argv[3])

if __name__ == "__main__":
    main()